/*********************************************************************
  KEcount.c

  Counts how many 5-tuples from BigQSnoseries satisfy the
      (1) tiger
      (2) Kahler-Einstein
  conditions from Proposition 13

  **********************************************************************/

#include<stdio.h>
#include<stdlib.h>

main()
{
   int a[5];
   int i,j,k,l;
   int end;
   int d, try;
   int kecount;
   int notigercount;
   int iske, notiger;

   FILE *fp;
   FILE *nfp;
   
   fp = fopen("BigQSnoseries","r");
   nfp = fopen("KEtigers","w");

  
   end=fscanf(fp, "%d %d %d %d %d", &a[0],&a[1],&a[2],&a[3], &a[4]);

   kecount = 0;
   notigercount = 0;
 
   while(end > 0){
       
     notiger = 0;
     iske = 0;
     d = a[0] + a[1] + a[2] + a[3] + a[4] - 1;

     if(a[0]*a[1] > d - 1){
       notiger = 1; /* there is no tiger here */
     notigercount ++;
     }

     if(3*d < 4*a[0]*a[1]){
       iske = 1;
       kecount ++;
     }
   
    
     fprintf(nfp, "%7d %7d %7d %7d %7d", a[0],a[1],a[2],a[3],a[4]);
     if(notiger == 1)
       fprintf(nfp, "  no tiger");
     else
       fprintf(nfp, "      ?   ");

     if(iske == 1)
       fprintf(nfp, "   KE-metric ");
     else
       fprintf(nfp, "     ?   ");

     fprintf(nfp, "\n");

     end=fscanf(fp, "%d %d %d %d %d", &a[0],&a[1],&a[2],&a[3], &a[4]);
} /* end of while loop to read orderedbigqs */

   fclose( fp );
   fclose( nfp );

   printf("We did not find %d tigers.\n", notigercount);
   printf("We found %d KE-metrics. \n", kecount);
} /* end of main */






