/*********************************************************************
  boundm0m1.c

  Read in 8 numbers from the file "detcoefficients" to be further
  processed.

  First we find a0 and b0 where d0 = a0*m1 + b0.
  Next we find a1 and b1 where d1 = a1*m0 + b1.
  Finally we find c2,c0,c1,c3 where
 
          det C = c2*m0*m1 + c0*m0 + c1*m1 + c3
  
  Let e2 = c2, e0 = c0, e1 = c1-a0, e3 = c3 - b0.

  

  Compute the maximum of -(c0 + c1)(+/-)sqrt( (c0 + c1)^2 - 4*c2c3 )
                              --------------------------------------------
                                                2c2
                             similar expression in e's
                       
                             0

                            -c0/c2 

                            -c1/c2 

                            -e0/e2 

                            -e1/e2
  
**********************************************************************/

#include<stdio.h>
#include<stdlib.h>
#include<math.h>

main()
{

   int a0,b0,a1,b1,c0,c1,c2,c3;
   int e0,e1,e2,e3;
   int end;

   float csum, esum;
   float x,y,cplus,cminus,eplus,eminus,q1,q2,q3,q4;
   float max, totalmax;
   
   FILE *fp;
   FILE *nfp;

  
  /* read in the first 5tuple from the file */
  
   fp = fopen("detcoefficients", "r");
  nfp = fopen("bounds", "w");
  
  end=fscanf( fp, "%d %d %d %d %d %d %d %d",&a0,&b0,&a1,&b1,&c2,&c0,&c1,&c3);
  
  totalmax = 0.0;
 
  while(end > 0){

   max = 0.0;
   e2 = c2; 
   e0 = c0;
   e1 = c1-a0;
   e3 = c3-b0;

      csum = c0 + c1;
      cplus = ((-1.0)*csum + sqrt( csum*csum - 4.0*c2*c3))/(2.0*c2);
      esum = e0 + e1;
      eplus =  ((-1.0)*esum + sqrt( esum*esum - 4.0*e2*e3))/(2.0*e2);
      cminus = ((-1.0)*csum - sqrt( csum*csum - 4.0*c2*c3))/(2.0*c2);
      eminus = ((-1.0)*esum - sqrt( esum*esum - 4.0*e2*e3))/(2.0*e2);
      if(cplus > max)
         max = cplus;
      if(cminus > max)
         max = cminus;
      if(eplus > max)
         max = eplus;
      if(eminus > max)
         max = eminus;
      
      /*****************************************************************
      fprintf(nfp, "%d %d %d %d %d %d %d %d",a0,b0,a1,b1,c2,c0,c1,c3);
      fprintf(nfp,"\n");
      fprintf(nfp,"e0 = %d, e1 = %d, e2 = %d, e3 = %d\n", e0,e1,e2,e3);
      fprintf(nfp, "cplus = %f, cminus = %f,", cplus,cminus); 
      fprintf(nfp, "eplus = %f, eminus = %f\n",eplus,eminus);
      fprintf(nfp, "Of these the max is %f.\n", max);
      *****************************************************************/

      q1 = -1.0*c0/c2;
      q2 = -1.0*c1/c2;
      q3 = -1.0*e0/e2;
      q4 = -1.0*e1/e2;
      
      if(q1>max)
        max = q1;
      if(q2>max)
        max = q2;
      if(q3>max)
        max = q3;
      if(q4>max)
        max = q4;
      if(max > totalmax)
        totalmax = max;
      /****************************************************************
      fprintf(nfp, "%d %d %d %d %d %d %d %d",a0,b0,a1,b1,c2,c0,c1,c3);
      fprintf(nfp,"\n");
      fprintf(nfp,"e0 = %d, e1 = %d, e2 = %d, e3 = %d\n", e0,e1,e2,e3);
      fprintf(nfp, "-c0/c2 = %f, -c1/c2 = %f,", q1,q2); 
      fprintf(nfp, "-e0/e2 = %f, -e1/e2 = %f\n",q3,q4);
      fprintf(nfp, "Of these the max is %f.\n", max);
      ****************************************************************/
   
  end=fscanf( fp, "%d %d %d %d %d %d %d %d",&a0,&b0,&a1,&b1,&c2,&c0,&c1,&c3);
 } /* end of loop for reading in 5-tuples */

printf("The total max is %f.\n", totalmax);
 
   fclose( fp );
   fclose( nfp );

} /* end of main */






