/*********************************************************************
  ckqssmallt234.c

  Read in a 5-tuple a[0], a[1], a[2], a[3],a[4] from the file 
  "QScksmallt".  THis file is too big, so first check if the
   triple a[2],a[3],a[4] passes condition 1.  Those that survive
   this test get sent to "QS234OK" and they will be further
   tested by ckqssmallt.c and sent to "QSsmalltOK"

  Condition 1:

  For any 3 a[i],a[j],a[k] of the current 5-tuple check that
          d = a[0] + a[1] + a[2] + a[3] + a[4] - 1
  can be written as a linear combination
          d = b_i*a[i] + b_j*a[j] + b_k*a[k]
  where the integers b are greater than or equal to 0.

**********************************************************************/

#include<stdio.h>
#include<stdlib.h>

main()
{

   int a[5];
   int i,j,k,l;
   int keep, end;
   int d, try;
   int lincomb;
   int tripleOK, pairOK, keeptrying;
   int b1,b2,b3;
   int max1,max2,max3;
   int try1, try2;

   FILE *fp;
   FILE *nfp;

  
  /* read in the first 5tuple from the file */
  
   fp = fopen("QScksmallt", "r");
  nfp = fopen("QS234OK", "w");
  
  end=fscanf( fp, "%d %d %d %d %d", &a[0],&a[1],&a[2],&a[3], &a[4]);
  
  while(end>0){
    keep = 0;
    i = 2;
    j = 3;
    k = 4; 
    d = a[0] + a[1] + a[2] + a[3] + a[4] - 1;
 
  
           max1 = 1 + d/a[i]; 
           max2 = 1 + d/a[j]; 
           max3 = 1 + d/a[k];
               for(b1 = 0; b1 < max1; b1++){
	          for(b2 = 0; b2 < max2; b2++){
                      for(b3 = 0; b3 < max3; b3++){
                          if(d == b1*a[i]+b2*a[j]+b3*a[k])
                              keep = 1;
                      }
		  }
	       }
 
  if(keep == 1)
     fprintf(nfp, "%5d %5d %5d %5d %5d\n", a[0],a[1],a[2],a[3],a[4]);
  end=fscanf( fp, "%d %d %d %d %d", &a[0],&a[1],&a[2],&a[3], &a[4]);
 } /* end of loop for reading in 5-tuples */

 
   fclose( fp );
   fclose( nfp );
 
} /* end of main */






