/**************************************************************************

delpezzo5.c     --- Asks for upper bounds on the a[i]'s.  Looks at all 
                    5-tuples a[0] <= a[1] <= a[2] <= a[3] <= a[4]
                    and checks the following conditions:

                     (1) Any 4 of the a[i]'s is relatively prime.

                     (2) For every choice of i, there is a corresponding
                         choice of j so that d - a[j] is an integer
                         multiple of a[i].

                    WRITES "5tuples"

                    WARNING:  Bounds of 100 or more can result in
                    several days running time.

***************************************************************************/

#include <stdio.h>
#include <stdlib.h>

main()
{
  int k=5;        /* work with k-tuples */
  int M[5];       /* a0 runs from 1 to M[0],
                     a1 runs to M[1], etc */
  int min = 1;
  int a[5];       
  int i, j, n;
  int aOK;
  int t1,t2,t3,t4,t5;
  int d, iOK;
  int true = 1;
  int false = 0;

  FILE *fp;

  int gcd2(int a, int b){
      int r;
     
      if (a > b){
      r = a;
      a = b;
      b = r;
      }

      r = b%a;
      while (r > 0){
          b = a;
          a = r;
          r = b%a;
      }
      return a;
  }

  int gcd3(int a, int b, int c){
      return gcd2( gcd2(a,b), c);
  }

  /* Read in ranges for a0, a1, a2, a3, a4*/
  /* Initialize a=[1,1,1,1]            */

  for(i = 0; i < k; i++){
  printf("How far should a[%d] run?\n", i);
  scanf("%d", &M[i]);
  a[i] = 1; 
  }
  
  fp = fopen("5tuples", "w");
  fprintf( fp, "  %5d %5d %5d %5d %5d\n", M[0], M[1], M[2], M[3], M[4]);

  /* find all 5-tuples (a0<=a1<=a2<=a3<=a4) so that 
     any 4 are relatively prime              */

  for(a[0]=min; a[0]<=M[0]; a[0]++){
    printf("The current value of a[0] is %3d:\n", a[0]);
    for(a[1]=a[0]; a[1]<=M[1]; a[1]++){
      for(a[2]=a[1]; a[2]<=M[2]; a[2]++){
        for(a[3]=a[2]; a[3]<=M[3]; a[3]++){
          for(a[4]=a[3]; a[4]<=M[4]; a[4]++){
          t1 = gcd2(gcd3(a[0],a[1],a[2]), a[3]);
          t2 = gcd2(gcd3(a[0],a[1],a[2]), a[4]);
          t3 = gcd2(gcd3(a[0],a[1],a[3]), a[4]);
          t4 = gcd2(gcd3(a[0],a[2],a[3]), a[4]);
          t5 = gcd2(gcd3(a[1],a[2],a[3]), a[4]);

          aOK = t1*t2*t3*t4*t5;  /* If aOK = 1 then this 4-tuple satisfies
                                the relative primeness conditions.  We
                                need to check the solvability conditions. */
          if (aOK == true){
             d = a[0] + a[1] + a[2] + a[3] + a[4] - 1;
                            
	     i = 0;
            
            
            while( (aOK==true) && (i<k) ) {

	      iOK = false;        /* Assume that we cannot find a solution */ 
               j = 0;         /* Look at d-a[j].  If it is divisible by
                                 a[i] then the a[i] eqn is solvable.
                                 Set iOK = 1 and move on to the next i.
                                 Otherwise, try the next j until we have
                                 tried j = 3.                            */  
               while( (iOK ==false) && (j<k) ) {  
		 if ((d-a[j])%a[i]==0){
                    iOK = 1;
                    i++;
	         }
                 else j++;
               if ((iOK==false) && (j==k)) /* If we have checked j = 0, 1, 2, 3
                                         and d-a[j] was not a multiple of a[i]
                                         then this 4-tuple will not work and
                                         we need to move on to the next.  */    
                  aOK = false; 
	       }         /* This ends the j-while loop */
                        /* We have finished testing this 4-tuple.  If OK = 1 then
                        all the solvability conditions were met.  If OK = 0 then
                        this 4-tuple does not work. */
            } /* This ends the i-while loop. */
              if (aOK==true )
                fprintf(fp, "  %5d %5d %5d %5d %5d\n", a[0], a[1], a[2], a[3], a[4]);
                 printf(" %5d %5d %5d %5d %5d\n", a[0], a[1], a[2], a[3], a[4]);
	  } /* this ends the testing of the current 4-tuple. */
	  }
        }
      }
    }
  }
printf("That completes this run.\n");
 
fclose( fp );
  
  
}

