/*********************************************************************
  findm0m1.c        (this was a big testing program --- contains
                     the testing code, often commented out)

                    deals with the case c2 = 0 and c0*c1 nonzero.
                    END RESULT was that under these conditions a[0] and
                    a[1] are less than 9 if m0 + m1 is at least 36.


  Read in 8 numbers a0 b0 a1 b1 c2 c0 c1 c3 from the file "zerocorner" 
  to be further processed.  Here d0 = a0*m1 + b0,
                                 d1 = a1*m0 + b1
                              det C = c2*m0*m1 + c0*m0 + c1*m1 + c3
                                      (and c2 = 0 if in zerocorner)

  Using the fact that a0,a1,c0,c1 are less than or equal to 0
  we show that a[0] and a[1] must be smaller than 9 whenever m0 + m1 is
  at least 36.  Then we prove that the three linear forms a0m1 + b0,
  a1*m0 + b1, c0m0 + c1m1 + c3  are linearly dependent.
  
**********************************************************************/

#include<stdio.h>
#include<stdlib.h>


main()
{

   int a0,b0,a1,b1,c0,c1,c2,c3;
   float f0,g0,f1,g1,e0,e1,e2,e3;
   int s,t;
   int end;
   int count;
   int countdep;
   int countall;
   int countzeros;
   int deptest;
   float max;   
   float n1,n0,d0;
   float intercept0, intercept1;
   float m0,m1;
   float D0,D1,detC;
      
   FILE *fp;
   FILE *nfp;
   FILE *dfp;
  
  /* read in the first 8tuple of coefficients from the file */
  
   fp = fopen("zerocorner", "r");
  nfp = fopen("c2eq0results", "w");
  dfp = fopen("lindep", "w");

  end=fscanf( fp, "%d %d %d %d %d %d %d %d",&a0,&b0,&a1,&b1,&c2,&c0,&c1,&c3);  
  count = 0;
  countdep = 0;
  countall = 0;
  countzeros = 0;
  /******************************************************************
     We already checked that a0,a1,c0,c1 are less than or equal to 0
     for any 8-tuple in "zerocorner".  (See negative.c )
     Now we want to get bounds on m0 and m1.  
  ****************************************************************/

  max = 0.0;
  while(end > 0){
   countall ++;
   e0 = c0;
   e1 = c1;
   e2 = c2;
   e3 = c3;
   f0 = a0;
   g0 = b0;
   f1 = a1;
   g1 = b1;
   
   if(c0 == 0)
     countzeros ++;
   if(c1 == 0)
     countzeros ++; 
   /*********************************************************************
     We look at the intercepts of c0*m0 + c1*m1 + c3 in the case where
     c0 and c1 are both negative (in other words, neither is zero).
     Look at the intercepts m1 = -c3/c1 and m0 = -c3/c0.  What is
     the maximum value of these intercepts?  Since c0 and c1
     are both negative, we know that if we choose m0 and m1 large enough
     we will get a negative value for  c0*m0 + c1*m1 + c3 and therefore
     solutions to c0m0 +c1m1+c3<0 will lie above the line through those
     intercepts.  Using the code below we found that the largest intercept
     is 12.
   ******************************************************************/       
   /*****************************************************************
   if(c0 < 0 && c1 < 0){
     intercept0 = -1.0*e3/e0;
     intercept1 = -1.0*e3/e1;
     if(intercept0 > max)
       max = intercept0;
     if(intercept1 > max)
       max = intercept1;
     if(count % 1000 == 0){
       printf("%3d %3d %3d %3d %3d %3d %3d %3d\n", a0,b0,a1,b1,c2,c0,c1,c3);
       printf("m0 intercept = %f\n", intercept0);
       printf("m1 intercept = %f\n", intercept1);
     } 
   }
   ******************************************************************/       
   
   /***************************************************************
   **Conclusion:  c0m0+c1m1+c3 < 0 whenever m1+m2 is at least 12.**
   ***************************************************************/


   /*********************************************************************
     The results of the code above gave that c0m0+c1m1+c3<0 whenever
     m1+m2 is at least 12.  Next, we look at when 
              a0*m1 + b0                         a1*m0 + b1  
     a[0]=  ------------------ < 9 and a[1] = ------------------ < 9
            c0*m0 + c1*m1 + c3                c0*m0 + c1*m1 + c3
   
     Assuming m1 + m2 is at least 12 we have
        a0*m1 + b0 - 9(c0*m0 + c1*m1 + c3) is at least 0.  (**)

     Again look at the intercepts:
 
       (m0 = 0):  m1 = (9c3 - b0)/(a0 - 9c1)

       (m1 = 0):  m0 = (b0 - 9c3)/9c0
      
     Since a0<=0, c0<0,c1<0 we know that if m0 is large enough then
       -9c0m0 - 9c1m1 + a0m1 will be positive.  Therefore the inequality
     (**) will be solved by the values of m0 and m1 above the line
     m1 + m2 = maximum of these intercepts for all the 8-tuples in
     the file. 
     
     Using the code below we found that the maximum intercept was 36.
   ******************************************************************/
   /*****************************************************************
  
   if(c0 < 0 && c1 < 0){
     intercept1 = (9.0*e3 - g0)/(f0 - 9*e1);
     intercept0 = (g0 - 9.0*e3)/(9.0*e0);
     if(intercept0 > max)
       max = intercept0;
     if(intercept1 > max)
       max = intercept1;
     if(count % 1000 == 0){
       printf("%3d %3d %3d %3d %3d %3d %3d %3d\n", a0,b0,a1,b1,c2,c0,c1,c3);
       printf("m0 intercept = %f\n", intercept0);
       printf("m1 intercept = %f\n", intercept1);
     } 
   }
   *****************************************************************/
   /***************************************************************
   **    Conclusion: a[0]<9 whenever m1+m2 is at least 36.       **
   ***************************************************************/

   /**************************************************************
      Similarly we find a[1]<9 whenever m1+m2 is at least 36:
   *************************************************************/
 
   /*************************************************************** 
   if(c0 < 0 && c1 < 0){
     intercept1 = (g1-9.0*e3)/(9.0*e1);
     intercept0 = (9.0*e3 - g1)/(f1 - 9.0*e0);
     if(intercept0 > max)
       max = intercept0;
     if(intercept1 > max)
       max = intercept1;
     if(count % 1000 == 0){
       printf("%3d %3d %3d %3d %3d %3d %3d %3d\n", a0,b0,a1,b1,c2,c0,c1,c3);
       printf("m0 intercept = %f\n", intercept0);
       printf("m1 intercept = %f\n", intercept1);
     }
   }
   ******************************************************************/
     /***************************************************
        Now let s and t run from 1 to 8.  These represent
        choices of a[0] and a[1] within the range set
        above.  Use them to solve the system 
                 a0m1 + b0                a1*m0 + b1
         a[0] =--------------     a[1] = -------------
               c0m0 + c1m1 + c3          c0m0+c1m1+c3
 
       for m0 and m1.  What do we get?  That is, what is
       the largest value of m0, m1 we see.

        We have to worry about what happens when the 
        three linear expressions above
         a0m1+b0, a1m0 + b1, c0m0+c1m1+c3
        are linearly independent.  In that case we will
        get 0/0 forms...

       We can recognize this troublesome case by looking
       at the determinant:
             [ 0  a0  b0 ]
          det[ a1  0  b1 ] = a0b1c0 - a0a1c3 + b0a1c1
             [ c0 c1  c3 ]
       If this determinant is 0 then we write our 8
       coefficients to another file, called "lindep".
       Otherwise we compute a[0] and a[1] as above.
     ******************************************************/
 
   /*************************************************************   
 deptest = a0*b1*c0 - a0*a1*c3 + b0*a1*c1;
 if(deptest != 0)
   printf("found independent case");
   **************************************************************/

 if(c0 < 0 && c1 < 0){
   deptest = a0*b1*c0 - a0*a1*c3 + b0*a1*c1;
   if(deptest == 0){
     fprintf(dfp, "%3d %3d %3d %3d %3d %3d %3d %3d\n",a0,b0,a1,b1,c2,c0,c1,c3);
     countdep ++;
   }
   else{
     count ++;
     for(s=1; s<9; s++){
       for(t=1; t<9; t++){
 
          n0=(g0-s*e3)*t*e1 - (g1-t*e3)*(s*e1-f0);
          d0=s*e0*t*e1 - (t*e0-f1)*(s*e1 - f0);
          m0 = n0/d0;
         


          if(m0 > max)
             max = m0;

          n1 =s*e0*(g1-t*e3) - (t*e0 - f1)*(g0 - s*e3);
          m1 = n1/d0;


          if(m1>max)
            max = m1;

          D0 = f0*m1 + g0;
          D1 = f1*m0 + g1;
          detC = e0*m0 + e1*m1 + e3;

          fprintf(nfp,"(s,t)=(%3d,%3d): ", s,t);
          fprintf(nfp,"[ a[0], a[1] ] = [ %5.2f, %5.2f ]\n", D0/detC, D1/detC);
         
       }
     }
     }

 } 
 


   end=fscanf( fp, "%d %d %d %d %d %d %d %d",&a0,&b0,&a1,&b1,&c2,&c0,&c1,&c3);

} /* end of while --- loop to read in coefficients */

   printf( " The maximum mo,m1 found was %f.\n", max);
   printf("linearly independent in %d of %d cases.\n", count, countall);
   printf("linearly dependent in %d cases.\n", countdep);
   printf("c0 or c1 is zero in %d cases. \n", countzeros);
   fclose( fp );
   fclose( nfp );
   fclose( dfp );   
 
  
} /* end of main */






