/*******************************************************

normalnoreps.c

Read in a series from the file "seriesnormalized"
which is created by the "wkseries.c".
There are 5303 rows and each contains 10 numbers:

a[0] a[1] a[2] a[3] a[4] ps[0] ps[1] ps[2] ps[3] ps[4]

We want to remove all repetitions.

*******************************************************/
#include<stdio.h>
#include<stdlib.h>

main()
{
   int L[10];
   int lr[10];
   int M[5303][10];
   int i,j, k;
   int end;
   int different;
   int keep;
   int numlines;

   FILE *fp;
   FILE *nfp;
   FILE *kfp;
  
  /* Initialize the matrix M to be all zero */
   numlines = 5303;
 
   for(i=0; i<numlines; i++)
      for(j=0; j<10; j++)
         M[i][j] = 0;
   
  /* read in the first 10 numbers from the file seriesnormalized */
  
   fp = fopen("seriesnormalized", "r");
  kfp = fopen("normaltoclean", "w");
   
  end=fscanf( fp, "%d %d %d %d %d %d %d %d %d %d", 
        &L[0],&L[1],&L[2],&L[3],&L[4],&L[5],&L[6],&L[7],&L[8],&L[9]);

  i = 0; 
  keep = 1;
  while(i<numlines && end>0){

     if(keep == 1){
       for(j=0;j<10;j++){
            M[i][j] = L[j];
        printf("%3d ", M[i][j]);
       }
        i++;  /* move on to the next row */
        printf("\n");
     }
     
     end=fscanf( fp, "%d %d %d %d %d %d %d %d %d %d", 
        &L[0],&L[1],&L[2],&L[3],&L[4],&L[5],&L[6],&L[7],&L[8],&L[9]);
      
     keep = 1;   /* assume that this L will be next row of M */

      /* Compare the current value of L to all previous rows of M.
       If it matches any of them, we don't want to write this L
       again.  If it is different, it should be the next row.   */
      
     k = 0;
     while(k<i && keep == 1){
       different = 0; /* assume that row k and L are the same */
       for(j=0;j<10;j++)
	 if(M[k][j] != L[j])   
	   different = 1;         
       /* if different = 0 then this value of L matches a row
          we saw before, so we should move on. 
          Otherwise, we should compare to the next row of M. */
       keep = different;                  
       k++;	               
     } 
     /* if it does then keep = 0 and we should move on.                   */
     /* if it does not, then we should write this value of L to the next  */
     /* row of M and read in the next value for L */
     
  } 

  k = 0;
  while(M[k][0] != 0){
    for(j=0;j<5;j++){
       fprintf(kfp, "%3d ", M[k][j]);
    }
   
    for(j=5;j<10;j++){
       fprintf(kfp, "%3d ", M[k][j]);
    }
    fprintf(kfp,"\n");
    k++;
  }
  fclose(fp);
  fclose(kfp);
}
