/*********************************************************************
  rmSeriesTerms.c

  Read in the shift vectors from "48triples" (these are ps[1],ps[2],ps[3]
  the primitive shift vector from the 48 quasismooth series.) Make a
  48 x 3  matrix.

  Read in a 5-tuple a[0], a[1], a[2], a[3],a[4] from the file 
  "orderedBigQS". 

  Check if (1) a[0] = 2
           (2) a[4] = a[1] + a[2] + a[3] - 1
  If these are satisfied then we may have a 5-tuple that corresponds
  to a quasismooth series and we should throw it out of our list.
  Further checking is needed. To know that it belongs to one of the
  48 series we check if

    [ a[1],a[2],a[3] ]
  ----------------------- = ps[1],ps[2],ps[3] for one of the series
    gcd(a[1],a[2],a[3])        (does it match a row from the 48x3 matrix)

**********************************************************************/

#include<stdio.h>
#include<stdlib.h>

main()
{
   int M[48][3];
   int c[3];
   int a[5];
   int i,j,k,l;
   int throw, end;
   int d, try;
   int gcd2(int a, int b){
      int r;
     
      if (a > b){
      r = a;
      a = b;
      b = r;
      }

      r = b%a;
      while (r > 0){
          b = a;
          a = r;
          r = b%a;
      }
      return a;
  }

  int gcd3(int a, int b, int c){
      return gcd2( gcd2(a,b), c);
  }

   FILE *fp;
   FILE *nfp;
   FILE *kfp;

  
   fp = fopen("48triples", "r");
   kfp = fopen("orderedBigQS","r");
   nfp = fopen("BigQSnoseries","w");

   /* set up the matrix M */

   for(i = 0; i<48; i++)
     fscanf( fp, "%d %d %d", &M[i][0], &M[i][1], &M[i][2]);
   /*
   for(i = 0; i<48; i++){
     for(j = 0; j<3; j++)
       printf("%5d",M[i][j]);
     printf("\n");
     } */

   fclose(fp);

   end=fscanf(kfp, "%d %d %d %d %d", &a[0],&a[1],&a[2],&a[3], &a[4]);
  
   while(end > 0){
     
     throw = 1;
     if(a[0] != 2)
       throw = 0;
     if( a[4] != a[1] + a[2] + a[3] - 1)
       throw = 0;
     if(throw == 1){
       throw = 0;
        d =  gcd3(a[1],a[2],a[3]);
        for(i = 0; i<3; i++)
           c[i] = a[i+1]/d;
        for(j = 0; j<48; j++)
	  if (c[0] == M[j][0] && c[1] == M[j][1] && c[2] == M[j][2])
	    throw = 1; 
          
     } /* end of checking whether this shift matches one in 48triples */
           

  if(throw == 0)
     fprintf(nfp, "%5d %5d %5d %5d %5d\n", a[0],a[1],a[2],a[3],a[4]);
  end=fscanf(kfp, "%d %d %d %d %d", &a[0],&a[1],&a[2],&a[3], &a[4]);
} /* end of while loop to read orderedbigqs */

   fclose( fp );
   fclose( nfp );

} /* end of main */






