/*********************************************************************
  terminal.c 

  Read in a 5-tuple a[0], a[1], a[2], a[3],a[4] from the file 
  "qsOK". (This file is created by quasismooth.c --- see that
  file for the definition.)

  Now I want to check the following additional conditions on the
  5tuples that passed the quasismooth tests.:

  If all of the following conditions hold then write the 5-tuple
  to the file "terminalOK".

  (1) Any three of the a[i]'s are relatively prime.
  
  (2) For any pair a[i],a[j] we have
      
          (i) gcd(a[i],a[j]) divides d
   and   (ii) there is an a[k] st gcd(a[i],a[j]) divides a[k]-1

  (3) For any single a[i]
  
        either   (i) a[i] divides d
          or    (ii) if a[i] divides d-1 then there is j, k so that
                     a[i] divides a[j]-1 and a[k]-1
          or   (iii) if a[i] does not divide d or d-1 then there is
                     a j so that a[i] divides a[j]-1
**********************************************************************/

#include<stdio.h>
#include<stdlib.h>

main()
{

   int a[5];
   int i,j,k,l;
   int keep, end;
   int d, try;
   int lincomb;
   int tripleOK, pairOK, keeptrying, singleOK;
   int b1,b2,b3;
   int max1,max2,max3;
   int try1, try2;

    int gcd2(int a, int b){
      int r;
     
      if (a > b){
      r = a;
      a = b;
      b = r;
      }

      r = b%a;
      while (r > 0){
          b = a;
          a = r;
          r = b%a;
      }
      return a;
  }

  int gcd3(int a, int b, int c){
      return gcd2( gcd2(a,b), c);
  }

   FILE *fp;
   FILE *nfp;

  
  /* read in the first 5tuple from the file */
  
   fp = fopen("qsOK", "r");
  nfp = fopen("terminalOK", "w");
  
  end=fscanf( fp, "%d %d %d %d %d", &a[0],&a[1],&a[2],&a[3], &a[4]);
 
  while(end > 0){
    keep = 1;  /* assume this 5-tuple will work out */
    i = 0;
    j = i+1;
    k = j+1;
    d = a[0] + a[1] + a[2] + a[3] + a[4] - 1;
    while(keep==1 && i<3){
      j = i + 1;
      while(keep==1 && j <5){
        k = j + 1;
	while(keep==1 && k < 5){

           tripleOK = gcd3(a[i],a[j],a[k]);

          
 /* if tripleOK is larger than 1 at this point, then this 5-tuple
    has failed.  Otherwise, it equals 1 and we should move on to the
    next choice of i,j,k.                             */
    keep = tripleOK;
         k++;
	}
       j++;
      }
     i++;
    }
    /* That completes the condition 1 testing.  If keep is not 1
       we are done and we should move on to the next 5-tuple.
       Otherwise, we must check condition 2.                  */

    if(keep == 1){
       
      /* Test condition 2 */
      i = 0;
      j = i+1;
      while(keep == 1 && i < 4){
        j = i + 1;
	while(keep == 1 && j < 5){
	  pairOK = 0;  /* assume this pair will fail. */
          /* test this pair */
          if(d%gcd2(a[i],a[j]) == 0)
            keeptrying = 1;
          if(keeptrying==1){
          for(k=0;k<5;k++){
            if((a[k]-1)%gcd2(a[i],a[j])==0)
              pairOK = 1;
          } /* end of k-loop */
          } /* end of if keeptrying = 1 */
         
   /*  At this point we have finished checking the current pair a[i],a[j].
       If it was all right then pairOK = 1 and we should check the next
       pair.  If pairOK = 0, then this 5-tuple should be thrown out.      */
       
       keep = pairOK;
       j++;
	}
       i++;
      }   		

    } /* end of checking the conditions on pairs a[i],a[j] */
    
    /* test conditions on a single a[i] */
    if(keep == 1){
      i=0;
      while((keep==1) && i<5){
        singleOK = 0; /* assume that there is a problem with a[i] */
        if(d%a[i]==0)
           singleOK = 1;   /* end of first phase of testing.  If
                              singleOK = 1, then passed.  If singleOK
                              = 0, must test some more.              */
        if(singleOK == 0){
	  /* there are two cases.  If a[i] divides d-1, then we 
             need a j and a k so that a[i] divides a[j]-1 and
             a[k]-1.                                             */
          if( (d-1)%a[i] == 0 ){
	    for(j=0;j<4;j++){
	      for(k=j+1; k<5; k++){
                 if( ((a[j]-1)%a[i]==0) && ((a[k]-1)%a[i]==0) ) 
                      singleOK = 1;
              } /* end of k-loop */
            } /* end of j-loop */
          } /* end of case where a[i] divides d-1 */
          else{
              for(j=0; j<5; j++)
               if((a[j]-1)%a[i]==0)
                 singleOK = 1;
          } /* end of(else) case, where a[i] does not divide d-1 */
        } /* end of if singleOK = 0, second phase of testing */
        keep = singleOK; 
        i++;
      } /* end of while i = 0..5 loop */
    }/* end of tests on single a[i]'s for this 5-tuple */
  


  if(keep == 1)
     fprintf(nfp, "%5d %5d %5d %5d %5d\n", a[0],a[1],a[2],a[3],a[4]);
  end=fscanf( fp, "%d %d %d %d %d", &a[0],&a[1],&a[2],&a[3], &a[4]);
 } /* end of loop for reading in 5-tuples */

 
   fclose( fp );
   fclose( nfp );

} /* end of main */






