/*********************************************************************
  texmonomials.c

  Read in a 5-tuple a[0], a[1], a[2], a[3],a[4] from the file 
  "FindMonomialsFor".  Compute d = sum of a[i]'s - 1 and find all
   linear combinations so that
       
   b[0]*a[0] + b[1]*a[1] + b[2]*a[2] + b[3]*a[3] + b[4]*a[4] = d

   Write to a file "monomials.tex"  the tex commands that will
   produce the monomial

       x_0^b[0] * x_1^b[1] * x_2*b[2] * x_3*b[3] * x_4*b[4]
 
   in a nice form.  
**********************************************************************/

#include<stdio.h>
#include<stdlib.h>

main()
{

   int a[5];
   int b[5];
   int max[5];
   int i,j,k,l;
   int keep, end;
   int d, try;
   

   FILE *fp;
   FILE *nfp;

   fp = fopen("FindMonomialsFor", "r");
   nfp = fopen("monomials.tex", "w");
  
   end=fscanf( fp, "%d %d %d %d %d",&a[0], &a[1],&a[2],&a[3],&a[4]);
 
   while(end > 0){    
    d = a[0] + a[1] + a[2] + a[3] + a[4] - 1;
    fprintf(nfp, "$(%5d, %5d, %5d, %5d, %5d)$\n", a[0],a[1],a[2],a[3],a[4]);
    fprintf(nfp,"\n");

    for(i=0;i<5;i++)
      max[i] = 1 + d/a[i];

    fprintf(nfp,"$$"); /* start monomial list for this 5-tuple */

    for(b[0] = 0; b[0] < max[0]; b[0]++){
      for(b[1] = 0; b[1] < max[1]; b[1]++){
        for(b[2] = 0; b[2] < max[2]; b[2]++){
          for(b[3] = 0; b[3] < max[3]; b[3]++){
            for(b[4] = 0; b[4] < max[4]; b[4]++){
	      if(d == b[0]*a[0]+b[1]*a[1]+b[2]*a[2]+b[3]*a[3]+b[4]*a[4]){
                for(i=0;i<5;i++){
		  if(b[i] == 1)
                    fprintf(nfp, "x_%d", i);
                  else
                    if(b[i] != 0)
		      fprintf(nfp,"x_%d^{%d}", i, b[i]);
                } /* end of printing x_i loop */
                fprintf(nfp,",\\ ");
	      } /* end of if d is a l.c. of a's with these coeff */         
       	    } /* end of b[4] loop */
	  } /* end of b[3] loop */
	} /* end of b[2] loop */
      } /* end of b[1] loop */
    } /* end of b[0] loop */

    fprintf(nfp, "$$\n\n"); /* end of the monomial list for this 5-tuple */
    
    
    end=fscanf( fp, "%d %d %d %d %d", &a[0],&a[1],&a[2],&a[3], &a[4]);

   } /* end of while to read in 5tuples from bigQSok */
   fprintf(nfp,"\\end");
} /* end of main */






